// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: commonmodule/commonmodule.proto

package openfmb.commonmodule;

/**
 * <pre>
 * Intelligent Electronic Device is a device with a microprocessor that can contain one or more
 * (IEC61850) SERVERs. In the context of IEC61850, IED could be an electronic protection device, a
 * controller or even a laptop/desktop computer. &lt;b&gt;Modelling note&lt;/b&gt;: This class is not explicitly
 * defined in IEC61850-7-2 (but only in SCL: IEC61850-6). However, it is an important concept that
 * deserves its place in the meta-model. When the meta-model gets instantiated from a direct link to an
 * IED with an IEC61850 SERVER, we typically create an instance of the meta-model IED per connection.
 * When the meta-model gets instantiated from an SCL file, there is the full description of IED and its
 * functions.
 * </pre>
 *
 * Protobuf type {@code commonmodule.ForecastIED}
 */
public final class ForecastIED extends
    com.google.protobuf.GeneratedMessageV3 implements
    // @@protoc_insertion_point(message_implements:commonmodule.ForecastIED)
    ForecastIEDOrBuilder {
private static final long serialVersionUID = 0L;
  // Use ForecastIED.newBuilder() to construct.
  private ForecastIED(com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
    super(builder);
  }
  private ForecastIED() {
    sourceApplicationID_ = "";
  }

  @java.lang.Override
  @SuppressWarnings({"unused"})
  protected java.lang.Object newInstance(
      UnusedPrivateParameter unused) {
    return new ForecastIED();
  }

  public static final com.google.protobuf.Descriptors.Descriptor
      getDescriptor() {
    return openfmb.commonmodule.Commonmodule.internal_static_commonmodule_ForecastIED_descriptor;
  }

  @java.lang.Override
  protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
      internalGetFieldAccessorTable() {
    return openfmb.commonmodule.Commonmodule.internal_static_commonmodule_ForecastIED_fieldAccessorTable
        .ensureFieldAccessorsInitialized(
            openfmb.commonmodule.ForecastIED.class, openfmb.commonmodule.ForecastIED.Builder.class);
  }

  public static final int FORECASTVALUESOURCE_FIELD_NUMBER = 1;
  private openfmb.commonmodule.ForecastValueSource forecastValueSource_;
  /**
   * <pre>
   * UML inherited base object
   * </pre>
   *
   * <code>.commonmodule.ForecastValueSource forecastValueSource = 1 [(.uml.option_parent_message) = true];</code>
   * @return Whether the forecastValueSource field is set.
   */
  @java.lang.Override
  public boolean hasForecastValueSource() {
    return forecastValueSource_ != null;
  }
  /**
   * <pre>
   * UML inherited base object
   * </pre>
   *
   * <code>.commonmodule.ForecastValueSource forecastValueSource = 1 [(.uml.option_parent_message) = true];</code>
   * @return The forecastValueSource.
   */
  @java.lang.Override
  public openfmb.commonmodule.ForecastValueSource getForecastValueSource() {
    return forecastValueSource_ == null ? openfmb.commonmodule.ForecastValueSource.getDefaultInstance() : forecastValueSource_;
  }
  /**
   * <pre>
   * UML inherited base object
   * </pre>
   *
   * <code>.commonmodule.ForecastValueSource forecastValueSource = 1 [(.uml.option_parent_message) = true];</code>
   */
  @java.lang.Override
  public openfmb.commonmodule.ForecastValueSourceOrBuilder getForecastValueSourceOrBuilder() {
    return forecastValueSource_ == null ? openfmb.commonmodule.ForecastValueSource.getDefaultInstance() : forecastValueSource_;
  }

  public static final int SOURCEAPPLICATIONID_FIELD_NUMBER = 2;
  @SuppressWarnings("serial")
  private volatile java.lang.Object sourceApplicationID_ = "";
  /**
   * <pre>
   * For control, this is an application ID, unique within communication system, and if the message
   * is transformed between gateway the original source application ID should be kept.
   * </pre>
   *
   * <code>string sourceApplicationID = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   * @return The sourceApplicationID.
   */
  @java.lang.Override
  public java.lang.String getSourceApplicationID() {
    java.lang.Object ref = sourceApplicationID_;
    if (ref instanceof java.lang.String) {
      return (java.lang.String) ref;
    } else {
      com.google.protobuf.ByteString bs = 
          (com.google.protobuf.ByteString) ref;
      java.lang.String s = bs.toStringUtf8();
      sourceApplicationID_ = s;
      return s;
    }
  }
  /**
   * <pre>
   * For control, this is an application ID, unique within communication system, and if the message
   * is transformed between gateway the original source application ID should be kept.
   * </pre>
   *
   * <code>string sourceApplicationID = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   * @return The bytes for sourceApplicationID.
   */
  @java.lang.Override
  public com.google.protobuf.ByteString
      getSourceApplicationIDBytes() {
    java.lang.Object ref = sourceApplicationID_;
    if (ref instanceof java.lang.String) {
      com.google.protobuf.ByteString b = 
          com.google.protobuf.ByteString.copyFromUtf8(
              (java.lang.String) ref);
      sourceApplicationID_ = b;
      return b;
    } else {
      return (com.google.protobuf.ByteString) ref;
    }
  }

  public static final int SOURCEDATETIME_FIELD_NUMBER = 3;
  private long sourceDateTime_ = 0L;
  /**
   * <pre>
   * Message publication date time
   * </pre>
   *
   * <code>int64 sourceDateTime = 3 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   * @return The sourceDateTime.
   */
  @java.lang.Override
  public long getSourceDateTime() {
    return sourceDateTime_;
  }

  private byte memoizedIsInitialized = -1;
  @java.lang.Override
  public final boolean isInitialized() {
    byte isInitialized = memoizedIsInitialized;
    if (isInitialized == 1) return true;
    if (isInitialized == 0) return false;

    memoizedIsInitialized = 1;
    return true;
  }

  @java.lang.Override
  public void writeTo(com.google.protobuf.CodedOutputStream output)
                      throws java.io.IOException {
    if (forecastValueSource_ != null) {
      output.writeMessage(1, getForecastValueSource());
    }
    if (!com.google.protobuf.GeneratedMessageV3.isStringEmpty(sourceApplicationID_)) {
      com.google.protobuf.GeneratedMessageV3.writeString(output, 2, sourceApplicationID_);
    }
    if (sourceDateTime_ != 0L) {
      output.writeInt64(3, sourceDateTime_);
    }
    getUnknownFields().writeTo(output);
  }

  @java.lang.Override
  public int getSerializedSize() {
    int size = memoizedSize;
    if (size != -1) return size;

    size = 0;
    if (forecastValueSource_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(1, getForecastValueSource());
    }
    if (!com.google.protobuf.GeneratedMessageV3.isStringEmpty(sourceApplicationID_)) {
      size += com.google.protobuf.GeneratedMessageV3.computeStringSize(2, sourceApplicationID_);
    }
    if (sourceDateTime_ != 0L) {
      size += com.google.protobuf.CodedOutputStream
        .computeInt64Size(3, sourceDateTime_);
    }
    size += getUnknownFields().getSerializedSize();
    memoizedSize = size;
    return size;
  }

  @java.lang.Override
  public boolean equals(final java.lang.Object obj) {
    if (obj == this) {
     return true;
    }
    if (!(obj instanceof openfmb.commonmodule.ForecastIED)) {
      return super.equals(obj);
    }
    openfmb.commonmodule.ForecastIED other = (openfmb.commonmodule.ForecastIED) obj;

    if (hasForecastValueSource() != other.hasForecastValueSource()) return false;
    if (hasForecastValueSource()) {
      if (!getForecastValueSource()
          .equals(other.getForecastValueSource())) return false;
    }
    if (!getSourceApplicationID()
        .equals(other.getSourceApplicationID())) return false;
    if (getSourceDateTime()
        != other.getSourceDateTime()) return false;
    if (!getUnknownFields().equals(other.getUnknownFields())) return false;
    return true;
  }

  @java.lang.Override
  public int hashCode() {
    if (memoizedHashCode != 0) {
      return memoizedHashCode;
    }
    int hash = 41;
    hash = (19 * hash) + getDescriptor().hashCode();
    if (hasForecastValueSource()) {
      hash = (37 * hash) + FORECASTVALUESOURCE_FIELD_NUMBER;
      hash = (53 * hash) + getForecastValueSource().hashCode();
    }
    hash = (37 * hash) + SOURCEAPPLICATIONID_FIELD_NUMBER;
    hash = (53 * hash) + getSourceApplicationID().hashCode();
    hash = (37 * hash) + SOURCEDATETIME_FIELD_NUMBER;
    hash = (53 * hash) + com.google.protobuf.Internal.hashLong(
        getSourceDateTime());
    hash = (29 * hash) + getUnknownFields().hashCode();
    memoizedHashCode = hash;
    return hash;
  }

  public static openfmb.commonmodule.ForecastIED parseFrom(
      java.nio.ByteBuffer data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.commonmodule.ForecastIED parseFrom(
      java.nio.ByteBuffer data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.commonmodule.ForecastIED parseFrom(
      com.google.protobuf.ByteString data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.commonmodule.ForecastIED parseFrom(
      com.google.protobuf.ByteString data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.commonmodule.ForecastIED parseFrom(byte[] data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.commonmodule.ForecastIED parseFrom(
      byte[] data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.commonmodule.ForecastIED parseFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static openfmb.commonmodule.ForecastIED parseFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }
  public static openfmb.commonmodule.ForecastIED parseDelimitedFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input);
  }
  public static openfmb.commonmodule.ForecastIED parseDelimitedFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
  }
  public static openfmb.commonmodule.ForecastIED parseFrom(
      com.google.protobuf.CodedInputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static openfmb.commonmodule.ForecastIED parseFrom(
      com.google.protobuf.CodedInputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }

  @java.lang.Override
  public Builder newBuilderForType() { return newBuilder(); }
  public static Builder newBuilder() {
    return DEFAULT_INSTANCE.toBuilder();
  }
  public static Builder newBuilder(openfmb.commonmodule.ForecastIED prototype) {
    return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
  }
  @java.lang.Override
  public Builder toBuilder() {
    return this == DEFAULT_INSTANCE
        ? new Builder() : new Builder().mergeFrom(this);
  }

  @java.lang.Override
  protected Builder newBuilderForType(
      com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
    Builder builder = new Builder(parent);
    return builder;
  }
  /**
   * <pre>
   * Intelligent Electronic Device is a device with a microprocessor that can contain one or more
   * (IEC61850) SERVERs. In the context of IEC61850, IED could be an electronic protection device, a
   * controller or even a laptop/desktop computer. &lt;b&gt;Modelling note&lt;/b&gt;: This class is not explicitly
   * defined in IEC61850-7-2 (but only in SCL: IEC61850-6). However, it is an important concept that
   * deserves its place in the meta-model. When the meta-model gets instantiated from a direct link to an
   * IED with an IEC61850 SERVER, we typically create an instance of the meta-model IED per connection.
   * When the meta-model gets instantiated from an SCL file, there is the full description of IED and its
   * functions.
   * </pre>
   *
   * Protobuf type {@code commonmodule.ForecastIED}
   */
  public static final class Builder extends
      com.google.protobuf.GeneratedMessageV3.Builder<Builder> implements
      // @@protoc_insertion_point(builder_implements:commonmodule.ForecastIED)
      openfmb.commonmodule.ForecastIEDOrBuilder {
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return openfmb.commonmodule.Commonmodule.internal_static_commonmodule_ForecastIED_descriptor;
    }

    @java.lang.Override
    protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return openfmb.commonmodule.Commonmodule.internal_static_commonmodule_ForecastIED_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              openfmb.commonmodule.ForecastIED.class, openfmb.commonmodule.ForecastIED.Builder.class);
    }

    // Construct using openfmb.commonmodule.ForecastIED.newBuilder()
    private Builder() {

    }

    private Builder(
        com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      super(parent);

    }
    @java.lang.Override
    public Builder clear() {
      super.clear();
      bitField0_ = 0;
      forecastValueSource_ = null;
      if (forecastValueSourceBuilder_ != null) {
        forecastValueSourceBuilder_.dispose();
        forecastValueSourceBuilder_ = null;
      }
      sourceApplicationID_ = "";
      sourceDateTime_ = 0L;
      return this;
    }

    @java.lang.Override
    public com.google.protobuf.Descriptors.Descriptor
        getDescriptorForType() {
      return openfmb.commonmodule.Commonmodule.internal_static_commonmodule_ForecastIED_descriptor;
    }

    @java.lang.Override
    public openfmb.commonmodule.ForecastIED getDefaultInstanceForType() {
      return openfmb.commonmodule.ForecastIED.getDefaultInstance();
    }

    @java.lang.Override
    public openfmb.commonmodule.ForecastIED build() {
      openfmb.commonmodule.ForecastIED result = buildPartial();
      if (!result.isInitialized()) {
        throw newUninitializedMessageException(result);
      }
      return result;
    }

    @java.lang.Override
    public openfmb.commonmodule.ForecastIED buildPartial() {
      openfmb.commonmodule.ForecastIED result = new openfmb.commonmodule.ForecastIED(this);
      if (bitField0_ != 0) { buildPartial0(result); }
      onBuilt();
      return result;
    }

    private void buildPartial0(openfmb.commonmodule.ForecastIED result) {
      int from_bitField0_ = bitField0_;
      if (((from_bitField0_ & 0x00000001) != 0)) {
        result.forecastValueSource_ = forecastValueSourceBuilder_ == null
            ? forecastValueSource_
            : forecastValueSourceBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000002) != 0)) {
        result.sourceApplicationID_ = sourceApplicationID_;
      }
      if (((from_bitField0_ & 0x00000004) != 0)) {
        result.sourceDateTime_ = sourceDateTime_;
      }
    }

    @java.lang.Override
    public Builder mergeFrom(com.google.protobuf.Message other) {
      if (other instanceof openfmb.commonmodule.ForecastIED) {
        return mergeFrom((openfmb.commonmodule.ForecastIED)other);
      } else {
        super.mergeFrom(other);
        return this;
      }
    }

    public Builder mergeFrom(openfmb.commonmodule.ForecastIED other) {
      if (other == openfmb.commonmodule.ForecastIED.getDefaultInstance()) return this;
      if (other.hasForecastValueSource()) {
        mergeForecastValueSource(other.getForecastValueSource());
      }
      if (!other.getSourceApplicationID().isEmpty()) {
        sourceApplicationID_ = other.sourceApplicationID_;
        bitField0_ |= 0x00000002;
        onChanged();
      }
      if (other.getSourceDateTime() != 0L) {
        setSourceDateTime(other.getSourceDateTime());
      }
      this.mergeUnknownFields(other.getUnknownFields());
      onChanged();
      return this;
    }

    @java.lang.Override
    public final boolean isInitialized() {
      return true;
    }

    @java.lang.Override
    public Builder mergeFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      if (extensionRegistry == null) {
        throw new java.lang.NullPointerException();
      }
      try {
        boolean done = false;
        while (!done) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              done = true;
              break;
            case 10: {
              input.readMessage(
                  getForecastValueSourceFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000001;
              break;
            } // case 10
            case 18: {
              sourceApplicationID_ = input.readStringRequireUtf8();
              bitField0_ |= 0x00000002;
              break;
            } // case 18
            case 24: {
              sourceDateTime_ = input.readInt64();
              bitField0_ |= 0x00000004;
              break;
            } // case 24
            default: {
              if (!super.parseUnknownField(input, extensionRegistry, tag)) {
                done = true; // was an endgroup tag
              }
              break;
            } // default:
          } // switch (tag)
        } // while (!done)
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.unwrapIOException();
      } finally {
        onChanged();
      } // finally
      return this;
    }
    private int bitField0_;

    private openfmb.commonmodule.ForecastValueSource forecastValueSource_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.ForecastValueSource, openfmb.commonmodule.ForecastValueSource.Builder, openfmb.commonmodule.ForecastValueSourceOrBuilder> forecastValueSourceBuilder_;
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.ForecastValueSource forecastValueSource = 1 [(.uml.option_parent_message) = true];</code>
     * @return Whether the forecastValueSource field is set.
     */
    public boolean hasForecastValueSource() {
      return ((bitField0_ & 0x00000001) != 0);
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.ForecastValueSource forecastValueSource = 1 [(.uml.option_parent_message) = true];</code>
     * @return The forecastValueSource.
     */
    public openfmb.commonmodule.ForecastValueSource getForecastValueSource() {
      if (forecastValueSourceBuilder_ == null) {
        return forecastValueSource_ == null ? openfmb.commonmodule.ForecastValueSource.getDefaultInstance() : forecastValueSource_;
      } else {
        return forecastValueSourceBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.ForecastValueSource forecastValueSource = 1 [(.uml.option_parent_message) = true];</code>
     */
    public Builder setForecastValueSource(openfmb.commonmodule.ForecastValueSource value) {
      if (forecastValueSourceBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        forecastValueSource_ = value;
      } else {
        forecastValueSourceBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.ForecastValueSource forecastValueSource = 1 [(.uml.option_parent_message) = true];</code>
     */
    public Builder setForecastValueSource(
        openfmb.commonmodule.ForecastValueSource.Builder builderForValue) {
      if (forecastValueSourceBuilder_ == null) {
        forecastValueSource_ = builderForValue.build();
      } else {
        forecastValueSourceBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.ForecastValueSource forecastValueSource = 1 [(.uml.option_parent_message) = true];</code>
     */
    public Builder mergeForecastValueSource(openfmb.commonmodule.ForecastValueSource value) {
      if (forecastValueSourceBuilder_ == null) {
        if (((bitField0_ & 0x00000001) != 0) &&
          forecastValueSource_ != null &&
          forecastValueSource_ != openfmb.commonmodule.ForecastValueSource.getDefaultInstance()) {
          getForecastValueSourceBuilder().mergeFrom(value);
        } else {
          forecastValueSource_ = value;
        }
      } else {
        forecastValueSourceBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.ForecastValueSource forecastValueSource = 1 [(.uml.option_parent_message) = true];</code>
     */
    public Builder clearForecastValueSource() {
      bitField0_ = (bitField0_ & ~0x00000001);
      forecastValueSource_ = null;
      if (forecastValueSourceBuilder_ != null) {
        forecastValueSourceBuilder_.dispose();
        forecastValueSourceBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.ForecastValueSource forecastValueSource = 1 [(.uml.option_parent_message) = true];</code>
     */
    public openfmb.commonmodule.ForecastValueSource.Builder getForecastValueSourceBuilder() {
      bitField0_ |= 0x00000001;
      onChanged();
      return getForecastValueSourceFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.ForecastValueSource forecastValueSource = 1 [(.uml.option_parent_message) = true];</code>
     */
    public openfmb.commonmodule.ForecastValueSourceOrBuilder getForecastValueSourceOrBuilder() {
      if (forecastValueSourceBuilder_ != null) {
        return forecastValueSourceBuilder_.getMessageOrBuilder();
      } else {
        return forecastValueSource_ == null ?
            openfmb.commonmodule.ForecastValueSource.getDefaultInstance() : forecastValueSource_;
      }
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.ForecastValueSource forecastValueSource = 1 [(.uml.option_parent_message) = true];</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.ForecastValueSource, openfmb.commonmodule.ForecastValueSource.Builder, openfmb.commonmodule.ForecastValueSourceOrBuilder> 
        getForecastValueSourceFieldBuilder() {
      if (forecastValueSourceBuilder_ == null) {
        forecastValueSourceBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.commonmodule.ForecastValueSource, openfmb.commonmodule.ForecastValueSource.Builder, openfmb.commonmodule.ForecastValueSourceOrBuilder>(
                getForecastValueSource(),
                getParentForChildren(),
                isClean());
        forecastValueSource_ = null;
      }
      return forecastValueSourceBuilder_;
    }

    private java.lang.Object sourceApplicationID_ = "";
    /**
     * <pre>
     * For control, this is an application ID, unique within communication system, and if the message
     * is transformed between gateway the original source application ID should be kept.
     * </pre>
     *
     * <code>string sourceApplicationID = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     * @return The sourceApplicationID.
     */
    public java.lang.String getSourceApplicationID() {
      java.lang.Object ref = sourceApplicationID_;
      if (!(ref instanceof java.lang.String)) {
        com.google.protobuf.ByteString bs =
            (com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        sourceApplicationID_ = s;
        return s;
      } else {
        return (java.lang.String) ref;
      }
    }
    /**
     * <pre>
     * For control, this is an application ID, unique within communication system, and if the message
     * is transformed between gateway the original source application ID should be kept.
     * </pre>
     *
     * <code>string sourceApplicationID = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     * @return The bytes for sourceApplicationID.
     */
    public com.google.protobuf.ByteString
        getSourceApplicationIDBytes() {
      java.lang.Object ref = sourceApplicationID_;
      if (ref instanceof String) {
        com.google.protobuf.ByteString b = 
            com.google.protobuf.ByteString.copyFromUtf8(
                (java.lang.String) ref);
        sourceApplicationID_ = b;
        return b;
      } else {
        return (com.google.protobuf.ByteString) ref;
      }
    }
    /**
     * <pre>
     * For control, this is an application ID, unique within communication system, and if the message
     * is transformed between gateway the original source application ID should be kept.
     * </pre>
     *
     * <code>string sourceApplicationID = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     * @param value The sourceApplicationID to set.
     * @return This builder for chaining.
     */
    public Builder setSourceApplicationID(
        java.lang.String value) {
      if (value == null) { throw new NullPointerException(); }
      sourceApplicationID_ = value;
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * For control, this is an application ID, unique within communication system, and if the message
     * is transformed between gateway the original source application ID should be kept.
     * </pre>
     *
     * <code>string sourceApplicationID = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     * @return This builder for chaining.
     */
    public Builder clearSourceApplicationID() {
      sourceApplicationID_ = getDefaultInstance().getSourceApplicationID();
      bitField0_ = (bitField0_ & ~0x00000002);
      onChanged();
      return this;
    }
    /**
     * <pre>
     * For control, this is an application ID, unique within communication system, and if the message
     * is transformed between gateway the original source application ID should be kept.
     * </pre>
     *
     * <code>string sourceApplicationID = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     * @param value The bytes for sourceApplicationID to set.
     * @return This builder for chaining.
     */
    public Builder setSourceApplicationIDBytes(
        com.google.protobuf.ByteString value) {
      if (value == null) { throw new NullPointerException(); }
      checkByteStringIsUtf8(value);
      sourceApplicationID_ = value;
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }

    private long sourceDateTime_ ;
    /**
     * <pre>
     * Message publication date time
     * </pre>
     *
     * <code>int64 sourceDateTime = 3 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     * @return The sourceDateTime.
     */
    @java.lang.Override
    public long getSourceDateTime() {
      return sourceDateTime_;
    }
    /**
     * <pre>
     * Message publication date time
     * </pre>
     *
     * <code>int64 sourceDateTime = 3 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     * @param value The sourceDateTime to set.
     * @return This builder for chaining.
     */
    public Builder setSourceDateTime(long value) {

      sourceDateTime_ = value;
      bitField0_ |= 0x00000004;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Message publication date time
     * </pre>
     *
     * <code>int64 sourceDateTime = 3 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     * @return This builder for chaining.
     */
    public Builder clearSourceDateTime() {
      bitField0_ = (bitField0_ & ~0x00000004);
      sourceDateTime_ = 0L;
      onChanged();
      return this;
    }
    @java.lang.Override
    public final Builder setUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.setUnknownFields(unknownFields);
    }

    @java.lang.Override
    public final Builder mergeUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.mergeUnknownFields(unknownFields);
    }


    // @@protoc_insertion_point(builder_scope:commonmodule.ForecastIED)
  }

  // @@protoc_insertion_point(class_scope:commonmodule.ForecastIED)
  private static final openfmb.commonmodule.ForecastIED DEFAULT_INSTANCE;
  static {
    DEFAULT_INSTANCE = new openfmb.commonmodule.ForecastIED();
  }

  public static openfmb.commonmodule.ForecastIED getDefaultInstance() {
    return DEFAULT_INSTANCE;
  }

  private static final com.google.protobuf.Parser<ForecastIED>
      PARSER = new com.google.protobuf.AbstractParser<ForecastIED>() {
    @java.lang.Override
    public ForecastIED parsePartialFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      Builder builder = newBuilder();
      try {
        builder.mergeFrom(input, extensionRegistry);
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.setUnfinishedMessage(builder.buildPartial());
      } catch (com.google.protobuf.UninitializedMessageException e) {
        throw e.asInvalidProtocolBufferException().setUnfinishedMessage(builder.buildPartial());
      } catch (java.io.IOException e) {
        throw new com.google.protobuf.InvalidProtocolBufferException(e)
            .setUnfinishedMessage(builder.buildPartial());
      }
      return builder.buildPartial();
    }
  };

  public static com.google.protobuf.Parser<ForecastIED> parser() {
    return PARSER;
  }

  @java.lang.Override
  public com.google.protobuf.Parser<ForecastIED> getParserForType() {
    return PARSER;
  }

  @java.lang.Override
  public openfmb.commonmodule.ForecastIED getDefaultInstanceForType() {
    return DEFAULT_INSTANCE;
  }

}

